#ifndef CPPE_MEMORY_HPP
#define CPPE_MEMORY_HPP

namespace cppe {

/**@brief
 * Class for getting the memory size and usage of the system.
 */

class memory {
	public:
	
	static memory& inst() {
		static memory myself;
		return myself;
	}
	
	unsigned long ram_size() const {
		return _ram_size;
	}
	
	unsigned long ram_free() const {
		return _ram_free;
	}
	
	unsigned long ram_used() const {
		return _ram_size - _ram_free;
	}
	
	unsigned long swap_size() const {
		return _swap_size;
	}
	
	unsigned long swap_free() const {
		return _swap_size - _swap_used;
	}
	
	unsigned long swap_used() const {
		return _swap_used;
	}
	
	void update();
	
	private:
	memory() { update(); }
	
	unsigned long _ram_size;
	unsigned long _ram_free;
	unsigned long _swap_size;
	unsigned long _swap_used;
};

} //End namespace cppe

#endif

