#ifndef CPPE_STDOUT_HPP
#define CPPE_STDOUT_HPP

#include <string>
#include <iostream>

#include <cppe/output_base.hpp>

namespace cppe { 

/**@brief
 * stdout provide output to standard output.
 */

class stdout : public output_base {
	public:
	void write(output_base::Type type, const std::string& message) {
		if(type == output_base::ERROR)
			std::cerr<<message;
		else
			std::cout<<message;
	}
};

} //End namespace cppe

#endif
