#ifndef CPPE_SYSLOG_HPP
#define CPPE_SYSLOG_HPP

#include <string>

#include <syslog.h>
#include <stdarg.h>

#include <cppe/output_base.hpp>

namespace cppe {

/**@brief
 * syslog provide output to syslogd.
 */

class syslog : public output_base {
	public:
	syslog(const std::string& program_name) {
		openlog(program_name.c_str(), LOG_CONS, LOG_USER);
	}
	
	void write(output_base::Type type, const std::string& message) {
		if(type == output_base::ERROR)
			::syslog(LOG_ERR, message.c_str());
		else
			::syslog(LOG_INFO, message.c_str());
	}
	
	~syslog() throw() { closelog(); }
};

} //End namespace cppe

#endif
