#include <string>

#include <cppe/comment_filter.hpp>

namespace cppe {

using namespace std;

std::string::size_type comment_filter::find_comment(const std::string &line) const {
	string::size_type ret = line.size();
	vector<string>::const_iterator it = _comment_starters.begin();
	for(; it < _comment_starters.end(); ++it) {
		string::size_type found = line.find(*it);
		if(found != string::npos && found < ret) {
			ret = found;
		}
	}
	if(ret == line.size())
		return string::npos;
	return ret;
}

std::string::size_type comment_filter::find_comment(const std::string &line, std::string &comment) const {
	vector<string>::const_iterator com = _comment_starters.end();
	string::size_type ret = line.size();
	vector<string>::const_iterator it = _comment_starters.begin();
	for(; it < _comment_starters.end(); ++it) {
		string::size_type found = line.find(*it);
		if(found != string::npos && found < ret) {
			ret = found;
			com = it;
		}
	}

	comment.clear()	;
	if(com != _comment_starters.end())
		comment = *com;

	if(ret == line.size())
		return string::npos;
	return ret;
}

} //End namespace cppe
