#include <unistd.h>     //getpagesize
#include <fcntl.h>      //kvm_open & kvm_close
#include <kvm.h>        //kvm_getswapinfo, kvm_open & kvm_close
#include <sys/types.h>  //sysctlbyname
#include <sys/sysctl.h> //sysctlbyname

#include <cppe/memory.hpp>

namespace cppe {

void memory::update() {
	size_t tt = sizeof(_ram_size);
       	sysctlbyname("vm.stats.vm.v_page_count", &_ram_size, &tt, 0, 0);
	_ram_size *= getpagesize();
	
	tt = sizeof(_ram_free);
       	sysctlbyname("vm.stats.vm.v_free_count", &_ram_free, &tt, 0, 0);
	_ram_free *= getpagesize();
	
	struct kvm_swap swapinfo[1];
	kvm_t *kd;
       	kd = kvm_open(0, 0, 0, O_RDONLY, "kvm_open");
       	kvm_getswapinfo(kd, swapinfo, 1, 0);
	kvm_close(kd);
	_swap_size = swapinfo[0].ksw_total * getpagesize();
	_swap_used = swapinfo[0].ksw_used * getpagesize();
}

}

