#include <sys/types.h>  //sysctlbyname
#include <sys/sysctl.h> //sysctlbyname
#include <stdlib.h>	//getloadavg
#include <time.h>	//time, localtime

#include <cppe/system.hpp>

namespace cppe {

double cpu_load(LOAD_TYPE min) {
	double loadinfo[3];
	getloadavg(loadinfo, 3);
	
	if(min == ONE)
		return loadinfo[0];
	else if(min == FIVE)
		return loadinfo[1];
		
	return loadinfo[2];
}

unsigned long uptime(UPTIME_TYPE type) {
	int mib[2];
	mib[0] = CTL_KERN;
	mib[1] = KERN_BOOTTIME;
	struct timeval boottime;
	size_t bt_size = sizeof(boottime);
	sysctl(mib, 2, &boottime, &bt_size, 0, 0);
	time_t currenttime;
	time(&currenttime);
	unsigned long seconds = currenttime - boottime.tv_sec;
	switch(type) {
		case WEEKS:
			seconds /= 7;
		case DAYS:
			seconds /= 24;
		case HOURS:
			seconds /= 60;
		case MINUTES:
			seconds /= 60;
		case SECONDS:
			break;
	}
	return seconds;
}

}
