#include <editfile/conf_reader.hpp>

using namespace std;
using namespace cppe;

namespace editfile {

void conf_reader::process(int argc, char *argv[]) {
	cppe::para_reader pr(argc, argv);
	process_o_flag(pr);
	process_d_flag(pr);
	process_s_flag(pr);
	process_c_flag(pr);
	process_r_flag(pr);
	process_q_flag(pr);
	process_file(pr);
	process_option(pr);
}

void conf_reader::process_c_flag(cppe::para_reader &pr) {
	std::string comment_starters;
	if(pr.find_flag("c", comment_starters)) {
		cppe::field f(comment_starters);
		f.split(',');
		for(unsigned i = 0; i < f.fields(); ++i) {
			if(!f[i].empty())
				_filter.add_comment_starter(f[i].str());
		}
	}
	else
		_filter.add_comment_starter("#");
}

void conf_reader::process_option(cppe::para_reader &pr) {
	using namespace cppe;
	using namespace std;
	string option;
	vector<string> tmpv;
	pr.values_left(tmpv);
	if(tmpv.empty())
		throw conf_reader_exception("No keyword specified");

	unsigned int i = 0;
	while(true) {
		option += tmpv[i];
		++i;
		if(i < tmpv.size())
			option += " ";
		else
			break;
	}

	field f(option);

	if(_autodetect && option.find('=') != string::npos)
		_separator = '=';

	if(_separator == '\t')
		f.split();
	else {
		f.split(_separator);
		if(f[0].empty())
			throw conf_reader_exception("No keyword specified");
	}

	_keyword = f[0].str();
	if(f.fields() > 2)
		f.extend(1);

	if(f.fields() == 2)
		_value = f[1].str();

	if(_filter.find_comment(_keyword, _comment) == 0) {
		_comment_out = true;
		_add = false;
		_keyword.erase(0, _comment.size());
		if(_keyword.empty())
			throw conf_reader_exception("No keyword specified");
	}
}

} //End namespace editfile
