#include <set>
#include <string>

#include <editfstab/merge.hpp>
#include <cppe/output.hpp>

using namespace std;
using namespace cppe;

namespace editfstab {

void merge_options(field &file, field &user, vector<field*> &final) {
	vector<unsigned int> old_options;
	vector<unsigned int> new_options;

	set<string> special_flag;
	special_flag.insert("ro");
	special_flag.insert("rq");
	special_flag.insert("rw");
	special_flag.insert("sw");
	special_flag.insert("xx");

	bool found_special = false;
	user.split(',');
	for(unsigned int i = 0; i < user.fields(); ++i) {
		user[i].split('=');
		if(!found_special) {
			if(special_flag.find(user[i].str()) != special_flag.end()) {
				final.push_back(&(user[i]));
				found_special = true;
				continue;
			}
		}
		new_options.push_back(i);
	}

	found_special = false;
	file.split(',');
	for(unsigned int i = 0; i < file.fields(); ++i) {
		file[i].split('=');
		if(!found_special) {
			if(special_flag.find(file[i].str()) != special_flag.end()) {
				if(final.size() == 0)
					final.push_back(&(file[i]));
				found_special = true;
				continue;
			}
		}
		old_options.push_back(i);
	}

	for(unsigned int i = 0; i < old_options.size(); ++i) {
		bool found = false;
		for(unsigned int j = 0; j < new_options.size(); ++j) {
			if(file[old_options[i]][0] == user[new_options[j]][0]) {
				final.push_back(&(user[new_options[j]]));
				new_options.erase(new_options.begin() + j);
				found = true;
				break;
			}
		}
		if(!found)
			final.push_back(&(file[old_options[i]]));
	}

	for(unsigned int i = 0; i < new_options.size(); ++i) {
		final.push_back(&(user[new_options[i]]));
	}
}

} //End namespace editfstab
