#include <string>
#include <vector>
#include <iostream>

#include <cppe/comment_filter.hpp>
#include <cppe/filter_iterator.hpp>
#include <cppe/field.hpp>
#include <cppe/file.hpp>
#include <cppe/output.hpp>

#include <editkernel/conf_reader.hpp>

using namespace std;
using namespace cppe;
using namespace editkernel;

int main(int argc, char *argv[]) {
	try {
	conf_reader &cf = conf_reader::inst();
	cf.process(argc, argv);
	field user_option(cf.option());
	if(cf.hint()) {
		user_option.split('=');
		if(user_option.fields() == 1) {
			output::inst().write(output_base::ERROR, "Syntax error\n");
			return 0;
		}
	}
	else {
		user_option.split();
		if(user_option.fields() == 1) {
			output::inst().write(output_base::ERROR, "Syntax error\n");
			return 0;
		}
		user_option.extend(1);
		user_option[1].split('=');
	}
	comment_filter filter;
	filter.add_comment_starter("#");
	filter_iterator fi(filter);
	file f(cf.file());
	vector<string> tmp;
	f.read(tmp);
	vector<string>::iterator it = tmp.begin();
	for(; fi.next(it, tmp.end()); ++it) {
		field ff(*it, fi.first(), fi.last() - fi.first() + 1);
		ff.split();
		if(cf.hint()) {
			ff[0].split('=');
			if(ff[0].fields() == 1)
				continue;
			if(ff[0][0] != user_option[0])
				continue;
			(*it).replace(ff.begin(), ff.size(), cf.option());
			f.write(tmp);
			return 0;
		}
		if(ff.fields() == 1)
			continue;
		if(ff[0] != user_option[0])
			continue;
		ff[1].split('=');
		if(ff[1][0] != user_option[1][0])
			continue;
		(*it).replace(ff.begin(), ff.size(), user_option[0].str() + "\t\t" + user_option[1].str());
		f.write(tmp);
		return 0;
	}
	if(cf.hint())
		tmp.push_back(cf.option());
	else
		tmp.push_back(user_option[0].str() + "\t\t" + user_option[1].str());
	f.write(tmp);
	return 0;
	} //End try
	catch(editkernel_exception &e) {
		output::inst().write(output_base::ERROR, e.what() + "\n");
	}
	catch(file::not_found_exception &e) {
		output::inst().write(output_base::ERROR, "No such file: " + e.what() + "\n");
	}
	catch(cppe_exception &e) {
		output::inst().write(output_base::ERROR, "cppe_exception: " + e.what() + "\n");
	}
	catch(exception &e) {
		output::inst().write(output_base::ERROR, string(e.what()).append("\n"));
	}
	catch(...) {
		output::inst().write(output_base::ERROR, "Unknown exception\n");
	}
}
