#include <string>
#include <vector>
#include <set>

#include <cppe/comment_filter.hpp>
#include <cppe/filter_iterator.hpp>
#include <cppe/field.hpp>
#include <cppe/file.hpp>
#include <cppe/output.hpp>

#include <editlogin/conf_reader.hpp>

using namespace std;
using namespace cppe;
using namespace editlogin;

int main(int argc, char *argv[]) {
	try {
	conf_reader &cf = conf_reader::inst();
	cf.process(argc, argv);
	comment_filter filter;
	filter.add_comment_starter("#");
	file f(cf.file());
	filter_iterator fi(filter);
	vector<string> tmp;
	f.read(tmp);
	field user_option(cf.option());
	user_option.split('=');
	vector<string>::iterator it = tmp.begin();
	for(; fi.next(it, tmp.end()); ++it) {	//Find login class
		field option(*it, fi.first(), fi.last() - fi.first() + 1);
		option.split('|');
		bool found = false;
		for(unsigned int i = 0; true;++i) {
			if(i == option.fields() - 1) {
				if(option[i].size() < 3)
					break;
				if((*it).compare(option[i].begin(), option[i].size() - 2, cf.login_class()) == 0) {
					found = true;
					break;
				}
				break;
			}
			if(cf.login_class() == option[i]) {
				found = true;
				break;
			}
		}

		if(!found)
			continue;

		vector<string>::iterator lclass = it;
		++it;
		for(; fi.next(it, tmp.end()); ++it) {
			field file_option(*it, fi.first(), fi.last() - fi.first() + 1);
			if((*it).at(fi.first()) != ':') {
				it = tmp.end();
			}
			file_option.split(':');
			if(file_option.size() == 1 || !file_option[0].empty()) {
				output::inst().write(output_base::ERROR, "Syntax error: " + *it + "\n");
				return 0;
			}
			file_option[1].split('=');
			if(file_option[1][0] == user_option[0]) {
				(*it).replace(file_option[1].begin(), file_option[1].size(), cf.option());
				f.write(tmp);
				return 0;
			}
			if((*it).at(fi.last()) == ':')
				break;
		}
		if(it == tmp.end())	//there were no options
			tmp.insert(++lclass, "\t:" + cf.option() + ":");
		else
			tmp.insert(it, "\t:" + cf.option() + ":\\");
		f.write(tmp);
		break;
	}
	return 0;
	} //End try
	catch(editlogin_exception &e) {
		output::inst().write(output_base::ERROR, e.what() + "\n");
	}
	catch(file::not_found_exception &e) {
		output::inst().write(output_base::ERROR, "No such file: " + e.what() + "\n");
	}
	catch(cppe_exception &e) {
		output::inst().write(output_base::ERROR, "cppe_exception: " + e.what() + "\n");
	}
	catch(exception &e) {
		output::inst().write(output_base::ERROR, string(e.what()).append("\n"));
	}
	catch(...) {
		output::inst().write(output_base::ERROR, "Unknown exception\n");
	}
}
